---
 Doc/library/urlparse.rst                                           |   20 ++++++++
 Lib/test/test_urlparse.py                                          |   24 ++++++++++
 Lib/urlparse.py                                                    |   17 +++++++
 Misc/NEWS.d/next/Security/2019-03-06-09-38-40.bpo-36216.6q1m4a.rst |    3 +
 4 files changed, 64 insertions(+)

--- a/Doc/library/urlparse.rst
+++ b/Doc/library/urlparse.rst
@@ -30,6 +30,16 @@ following URL schemes: ``file``, ``ftp``
 ``rsync``, ``rtsp``, ``rtspu``,  ``sftp``, ``shttp``, ``sip``, ``sips``,
 ``snews``, ``svn``,  ``svn+ssh``, ``telnet``, ``wais``.
 
+Characters in the :attr:`netloc` attribute that decompose under
+NFKC normalization (as used by the IDNA encoding) into any of
+``/``, ``?``, ``#``, ``@``, or ``:`` will raise
+a :exc:`ValueError`. If the URL is decomposed before parsing, or
+is not a Unicode string, no error will be raised.
+
+.. versionchanged:: 2.7.17
+   Characters that affect netloc parsing under NFKC normalization will
+   now raise :exc:`ValueError`.
+
 .. versionadded:: 2.5
    Support for the ``sftp`` and ``sips`` schemes.
 
@@ -195,11 +205,21 @@ The :mod:`urlparse` module defines the f
    See section :ref:`urlparse-result-object` for more information on the result
    object.
 
+   Characters in the :attr:`netloc` attribute that decompose under NFKC
+   normalization (as used by the IDNA encoding) into any of ``/``, ``?``,
+   ``#``, ``@``, or ``:`` will raise a :exc:`ValueError`. If the URL is
+   decomposed before parsing, or is not a Unicode string, no error will be
+   raised.
+
    .. versionadded:: 2.2
 
    .. versionchanged:: 2.5
       Added attributes to return value.
 
+   .. versionchanged:: 2.7.17
+      Characters that affect netloc parsing under NFKC normalization will
+      now raise :exc:`ValueError`.
+
 
 .. function:: urlunsplit(parts)
 
--- a/Lib/test/test_urlparse.py
+++ b/Lib/test/test_urlparse.py
@@ -1,6 +1,8 @@
 #! /usr/bin/env python
 
 from test import test_support
+import sys
+import unicodedata
 import unittest
 import urlparse
 
@@ -477,6 +479,28 @@ class UrlParseTestCase(unittest.TestCase
 
 
 
+    def test_urlsplit_normalization(self):
+        # Certain characters should never occur in the netloc,
+        # including under normalization.
+        # Ensure that ALL of them are detected and cause an error
+        illegal_chars = u'/:#?@'
+        hex_chars = set(('{0:04X}'.format(ord(c)) for c in illegal_chars))
+        denorm_chars = [
+            c for c in map(unichr, range(128, sys.maxunicode))
+            if (hex_chars & set(unicodedata.decomposition(c).split()))
+            and c not in illegal_chars
+        ]
+        # Sanity check that we found at least one such character
+        self.assertTrue(u'\u2100' in denorm_chars)
+        self.assertTrue(u'\uFF03' in denorm_chars)
+
+        for scheme in [u"http", u"https", u"ftp"]:
+            for c in denorm_chars:
+                url = u"{0}://netloc{1}false.netloc/path".format(scheme, c)
+                if test_support.verbose:
+                    print "Checking %r" % url
+                self.assertRaises(ValueError, urlparse.urlsplit, url)
+
 def test_main():
     test_support.run_unittest(UrlParseTestCase)
 
--- a/Lib/urlparse.py
+++ b/Lib/urlparse.py
@@ -153,6 +153,21 @@ def _splitnetloc(url, start=0):
             delim = min(delim, wdelim)     # use earliest delim position
     return url[start:delim], url[delim:]   # return (domain, rest)
 
+def _checknetloc(netloc):
+    if not netloc or not isinstance(netloc, unicode):
+        return
+    # looking for characters like \u2100 that expand to 'a/c'
+    # IDNA uses NFKC equivalence, so normalize for this check
+    import unicodedata
+    netloc2 = unicodedata.normalize('NFKC', netloc)
+    if netloc == netloc2:
+        return
+    _, _, netloc = netloc.rpartition('@') # anything to the left of '@' is okay
+    for c in '/?#@:':
+        if c in netloc2:
+            raise ValueError("netloc '" + netloc2 + "' contains invalid " +
+                             "characters under NFKC normalization")
+
 def urlsplit(url, scheme='', allow_fragments=True):
     """Parse a URL into 5 components:
     <scheme>://<netloc>/<path>?<query>#<fragment>
@@ -182,6 +197,7 @@ def urlsplit(url, scheme='', allow_fragm
                 url, fragment = url.split('#', 1)
             if '?' in url:
                 url, query = url.split('?', 1)
+            _checknetloc(netloc)
             v = SplitResult(scheme, netloc, url, query, fragment)
             _parse_cache[key] = v
             return v
@@ -201,6 +217,7 @@ def urlsplit(url, scheme='', allow_fragm
         url, fragment = url.split('#', 1)
     if scheme in uses_query and '?' in url:
         url, query = url.split('?', 1)
+    _checknetloc(netloc)
     v = SplitResult(scheme, netloc, url, query, fragment)
     _parse_cache[key] = v
     return v
--- /dev/null
+++ b/Misc/NEWS.d/next/Security/2019-03-06-09-38-40.bpo-36216.6q1m4a.rst
@@ -0,0 +1,3 @@
+Changes urlsplit() to raise ValueError when the URL contains characters that
+decompose under IDNA encoding (NFKC-normalization) into characters that
+affect how the URL is parsed.
\ No newline at end of file
